commit de738988ff62b76e433f2fce570fcd8ab4b16c07
Author: Ian Lance Taylor <iant@golang.org>
Date:   Tue Aug 6 01:07:12 2024

    compiler: panic arguments are empty interface type
    
    After CL 536643 passing NULL as the expected type permitted an untyped
    constant expression to remain untyped. Change to passing the empty
    interface type.
    
    The panic and print/println functions are the only builtin functions
    that turn an untyped constant expression into a regular function call,
    and we already handled print/println specially.
    
    The test case is https://go.dev/cl/603096.
    
    Fixes golang/go#68734
    
    Reviewed-on: https://go-review.googlesource.com/c/gofrontend/+/603215

diff --git a/gcc/go/gofrontend/expressions.cc b/gcc/go/gofrontend/expressions.cc
index 238d5a56ca2..2b0e40fc6f8 100644
--- a/gcc/go/gofrontend/expressions.cc
+++ b/gcc/go/gofrontend/expressions.cc
@@ -11137,6 +11137,12 @@ Builtin_call_expression::do_determine_type(Gogo* gogo,
       is_print = false;
       break;
 
+    case BUILTIN_PANIC:
+      arg_type =
+	Type::make_empty_interface_type(Linemap::predeclared_location());
+      is_print = false;
+      break;
+
     case BUILTIN_PRINT:
     case BUILTIN_PRINTLN:
       // Do not force a large integer constant to "int".

